Index: branches/2012/dev_r3452_UKMO2_DIADCT/DOC/TexFiles/Chapters/Chap_DIA.tex
===================================================================
--- branches/2012/dev_r3452_UKMO2_DIADCT/DOC/TexFiles/Chapters/Chap_DIA.tex	(revision 3517)
+++ branches/2012/dev_r3452_UKMO2_DIADCT/DOC/TexFiles/Chapters/Chap_DIA.tex	(revision 3518)
@@ -836,7 +836,7 @@
 - \texttt{volume\_transport} for volume transports (  unit: $10^{6} m^{3} s^{-1}$ )
 
-- \texttt{heat\_transport}   for heat transports   (  unit: $10^{15} W $ )
-
-- \texttt{salt\_transport}   for salt transports   (  unit: $10^{9}g s^{-1}$ )\\
+- \texttt{heat\_transport}   for heat transports   (  unit: $W$ )
+
+- \texttt{salt\_transport}   for salt transports   (  unit: $kg s^{-1}$ )\\
 
 
Index: branches/2012/dev_r3452_UKMO2_DIADCT/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90
===================================================================
--- branches/2012/dev_r3452_UKMO2_DIADCT/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 3517)
+++ branches/2012/dev_r3452_UKMO2_DIADCT/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 3518)
@@ -21,11 +21,11 @@
   !!----------------------------------------------------------------------
   !!----------------------------------------------------------------------
-  !!   dia_dct      :  compute the transport through a sec.
-  !!   dia_dct_init :  read namelist.
-  !!   readsec      :  read sections description and pathway
-  !!   removepoints :  remove points which are common to 2 procs
+  !!   dia_dct      :  Compute the transport through a sec.
+  !!   dia_dct_init :  Read namelist.
+  !!   readsec      :  Read sections description and pathway
+  !!   removepoints :  Remove points which are common to 2 procs
   !!   transport    :  Compute transport for each sections
-  !!   dia_dct_wri  :  write tranports results in ascii files
-  !!   interp       :  compute Temperature/Salinity/density on U-point or V-point
+  !!   dia_dct_wri  :  Write tranports results in ascii files
+  !!   interp       :  Compute temperature/salinity/density at U-point or V-point
   !!   
   !!----------------------------------------------------------------------
@@ -95,5 +95,5 @@
      INTEGER                                      :: nb_class          ! number of boundaries for density classes
      INTEGER, DIMENSION(nb_point_max)             :: direction         ! vector direction of the point in the section
-     CHARACTER(len=40),DIMENSION(nb_class_max)    :: classname         ! caracteristics of the class
+     CHARACTER(len=40),DIMENSION(nb_class_max)    :: classname         ! characteristics of the class
      REAL(wp), DIMENSION(nb_class_max)            :: zsigi           ,&! in-situ   density classes    (99 if you don't want)
                                                      zsigp           ,&! potential density classes    (99 if you don't want)
@@ -309,5 +309,4 @@
      INTEGER :: isec, iiglo, ijglo, iiloc, ijloc,iost,i1 ,i2  ! temporary  integer
      INTEGER :: jsec, jpt                                     ! dummy loop indices
-                                                              ! heat/salt tranport is actived
 
      INTEGER, DIMENSION(2) :: icoord 
@@ -501,7 +500,5 @@
      !!             *** function removepoints
      !!
-     !!   ** Purpose ::
-     !!              remove points which are common to 2 procs
-     !!
+     !!   ** Purpose :: Remove points which are common to 2 procs
      !!
      !----------------------------------------------------------------------------
@@ -595,6 +592,6 @@
      !!              loop on the level jk !!
      !! 
-     !!  Output  ::  Arrays containing the volume,density,salinity,temperature etc 
-     !!              transports for each point in a section, summed over each nn_dct. 
+     !!  Output  ::  Arrays containing the volume,density,heat,salt transports for each i
+     !!              point in a section, summed over each nn_dct. 
      !!
      !!-------------------------------------------------------------------------------------------
@@ -698,5 +695,5 @@
            DO jk=1,mbathy(k%I,k%J) 
  
-              ! compute temparature, salinity, insitu & potential density, ssh and depth at U/V point 
+              ! compute temperature, salinity, insitu & potential density, ssh and depth at U/V point 
               SELECT CASE( sec%direction(jseg) ) 
               CASE(0,1) 
@@ -745,6 +742,6 @@
                  transports_3d(2,jsec,jseg,jk) = transports_3d(2,jsec,jseg,jk)  + zTnorm * zrhoi 
                  transports_3d(3,jsec,jseg,jk) = transports_3d(3,jsec,jseg,jk)  + zTnorm * zrhop 
-                 transports_3d(4,jsec,jseg,jk) = transports_3d(4,jsec,jseg,jk)  + zTnorm * ztn 
-                 transports_3d(5,jsec,jseg,jk) = transports_3d(5,jsec,jseg,jk)  + zTnorm * zsn 
+                 transports_3d(4,jsec,jseg,jk) = transports_3d(4,jsec,jseg,jk)  + zTnorm * (ztn + 273.15) * zrhop * rcp
+                 transports_3d(5,jsec,jseg,jk) = transports_3d(5,jsec,jseg,jk)  + zTnorm * zsn * zrhop * 0.001
               ENDIF
    
@@ -787,5 +784,5 @@
         ENDDO !end of loop on the segment
 
-     ENDIF   !end of sec%nb_point =0 case
+     ENDIF !end of sec%nb_point =0 case
      !
   END SUBROUTINE transport
@@ -796,7 +793,6 @@
      !! and sum over the density/salinity/temperature/depth classes 
      !! 
-     !! Method:  
-     !!           Sum over relevant grid cells to obtain values 
-     !!           for each 
+     !! Method:   Sum over relevant grid cells to obtain values  
+     !!           for each class
      !!              There are several loops:                  
      !!              loop on the segment between 2 nodes 
@@ -805,8 +801,8 @@
      !!              test on the density/temperature/salinity/level 
      !! 
-     !!  ** Method  :Transport through a given section is equal to the sum of transports 
-     !!              computed on each proc. 
-     !!              On each proc,transport is equal to the sum of transport computed through 
-     !!              segments linking each point of sec%listPoint  with the next one.    
+     !!  Note:    Transport through a given section is equal to the sum of transports 
+     !!           computed on each proc. 
+     !!           On each proc,transport is equal to the sum of transport computed through 
+     !!           segments linking each point of sec%listPoint  with the next one.    
      !! 
      !!------------------------------------------------------------- 
@@ -816,5 +812,5 @@
  
      TYPE(POINT_SECTION) :: k 
-     INTEGER  :: jk,jseg,jclass                        !loop on level/segment/classes  
+     INTEGER  :: jk,jseg,jclass                        ! dummy variables for looping on level/segment/classes  
      REAL(wp) :: ztn, zsn, zrhoi, zrhop, zsshn, zfsdep ! temperature/salinity/ssh/potential density /depth at u/v point 
      !!------------------------------------------------------------- 
@@ -891,5 +887,5 @@
               !  LOOP ON THE DENSITY CLASSES | 
               !------------------------------- 
-              !The computation is made for each density/heat/salt/... class 
+              !The computation is made for each density/temperature/salinity/depth class 
               DO jclass=1,MAX(1,sec%nb_class-1) 
  
@@ -1015,8 +1011,8 @@
      !! 
      !!        2. Write heat transports in "heat_transport"
-     !!           Unit: Peta W : area * Velocity * T * rhau * Cp / 1.e15
+     !!           Unit: W : area * Velocity / 1.e6 * T(in Kelvin) * rhop * Cp
      !! 
      !!        3. Write salt transports in "salt_transport"
-     !!           Unit: 10^9 g m^3 / s : area * Velocity * S / 1.e6
+     !!           Unit: Kg/s : area * Velocity / 1.e6 * S * 1.e-3 
      !!
      !!------------------------------------------------------------- 
@@ -1152,5 +1148,5 @@
   !!----------------------------------------------------------------------
   !!
-  !!   Purpose: compute Temperature/Salinity/density at U-point or V-point
+  !!   Purpose: compute temperature/salinity/density at U-point or V-point
   !!   --------
   !!
@@ -1161,7 +1157,7 @@
   !! 
   !!
-  !!    |    I          |    I+1           |    Z=Temperature/Salinity/density at U-poinT
+  !!    |    I          |    I+1           |    Z=temperature/salinity/density at U-poinT
   !!    |               |                  |
-  !!  ----------------------------------------  1. Veritcale interpolation: compute zbis
+  !!  ----------------------------------------  1. Veritcal interpolation: compute zbis
   !!    |               |                  |       interpolation between ptab(I,J,K) and ptab(I,J,K+1)
   !!    |               |                  |       zbis = 
@@ -1244,5 +1240,5 @@
      zdep2 = fsdept(ii2,ij2,kk) - zdepu
 
-     !weights
+     ! weights
      zwgt1 = SQRT( ( 0.5 * zet1 ) * ( 0.5 * zet1 ) + ( zdep1 * zdep1 ) )
      zwgt2 = SQRT( ( 0.5 * zet2 ) * ( 0.5 * zet2 ) + ( zdep2 * zdep2 ) )
@@ -1271,10 +1267,10 @@
 
         IF( ze3t >= 0. )THEN 
-           !zbis
+           ! zbis
            zbis = ptab(ii2,ij2,kk) + zwgt1 * ( ptab(ii2,ij2,kk-1) - ptab(ii2,ij2,kk) ) 
            ! result
             interp = umask(ii1,ij1,kk) * ( zet2 * ptab(ii1,ij1,kk) + zet1 * zbis )/( zet1 + zet2 )
         ELSE
-           !zbis
+           ! zbis
            zbis = ptab(ii1,ij1,kk) + zwgt2 * ( ptab(ii1,ij1,kk-1) - ptab(ii1,ij2,kk) )
            ! result
@@ -1303,6 +1299,6 @@
    END SUBROUTINE dia_dct_init
 
-   SUBROUTINE dia_dct( kt )           ! Dummy routine
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
+   SUBROUTINE dia_dct( kt )         ! Dummy routine
+      INTEGER, INTENT( in ) :: kt   ! ocean time-step index
       WRITE(*,*) 'dia_dct: You should not have seen this print! error?', kt
    END SUBROUTINE dia_dct