Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_VARGAS
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_VARGAS	(revision 3531)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_VARGAS	(revision 3532)
@@ -60,11 +60,11 @@
   echo Directory is `pwd`
 # 
-#  Run the executable 
+#  Run the parallel MPI executable 
+#
+  echo "Running time ${MPIRUN} ./opa"
 #
   if [ MPI_FLAG == "yes" ]; then
-  echo "Running time ${MPIRUN} ./opa"
      time ${MPIRUN} ./opa
   else
-  echo "Running time ./opa"
      time ./opa
   fi
Index: /trunk/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg
===================================================================
--- /trunk/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg	(revision 3531)
+++ /trunk/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg	(revision 3532)
@@ -1,1 +1,1 @@
-ORCA2_LIM_PISCES_v3.4.tar
+ORCA2_LIM_nemo_v3.4.tar
Index: /trunk/NEMOGCM/SETTE/iodef_sette.xml
===================================================================
--- /trunk/NEMOGCM/SETTE/iodef_sette.xml	(revision 3531)
+++ /trunk/NEMOGCM/SETTE/iodef_sette.xml	(revision 3532)
@@ -209,28 +209,28 @@
 
      <group id="ptrc_T" axis_ref="deptht" grid_ref="grid_T">  
-       <field id="DIC"      description="Dissolved inorganic Concentration"        unit="molC/L"     />
-       <field id="Alkalini" description="Total Alkalinity Concentration"           unit="eq/L"       />
-       <field id="O2"       description="Oxygen Concentration"                     unit="molO2/L"    />
-       <field id="CaCO3"    description="Calcite Concentration"                    unit="molC/L"     />
-       <field id="PO4"      description="Phosphate Concentration"                  unit="molC/L"     />
-       <field id="POC"      description="Small organic carbon Concentration"       unit="molC/L"     />
-       <field id="Si"       description="Silicate Concentration"                   unit="molSi/L"    />
-       <field id="PHY"      description="Nanophytoplankton Concentration"          unit="molC/L"     />
-       <field id="ZOO"      description="Microzooplankton Concentration"           unit="molC/L"     />
-       <field id="DOC"      description="Dissolved organic Concentration"          unit="molC/L"     />
-       <field id="PHY2"     description="Diatoms Concentration"                    unit="molC/L"     />
-       <field id="ZOO2"     description="Mesozooplankton Concentration"            unit="molC/L"     />
-       <field id="BSi"      description="Diatoms Silicate Concentration"           unit="molC/L"     />
-       <field id="Fer"      description="Dissolved Iron Concentration"             unit="molFe/L"    />
-       <field id="BFe"      description="Big iron particles Concentration"         unit="molFe/L"    />
-       <field id="GOC"      description="Big organic carbon Concentration"         unit="molC/L"     />
-       <field id="SFe"      description="Small iron particles Concentration"       unit="molFe/L"    />
-       <field id="DFe"      description="Diatoms iron  Concentration"              unit="molFe/L"    />
-       <field id="DSi"      description="Sinking biogenic Silicate Concentration"  unit="molC/L"     />
-       <field id="NFe"      description="Nano iron Concentration"                  unit="molC/L"     />
-       <field id="NCHL"     description="Nano chlorophyl Concentration"            unit="gChl/L"     />
-       <field id="DCHL"     description="Diatoms chlorophyl Concentration"         unit="gChl/L"     />
-       <field id="NO3"      description="Nitrates Concentration"                   unit="molC/L"     />
-       <field id="NH4"      description="Ammonium Concentration"                   unit="molC/L"     />
+       <field id="DIC"      description="Dissolved inorganic Concentration"        unit="mmol/m3" />
+       <field id="Alkalini" description="Total Alkalinity Concentration"           unit="mmol/m3"    />
+       <field id="O2"       description="Oxygen Concentration"                     unit="mmol/m3" />
+       <field id="CaCO3"    description="Calcite Concentration"                    unit="mmol/m3" />
+       <field id="PO4"      description="Phosphate Concentration"                  unit="mmol/m3" />
+       <field id="POC"      description="Small organic carbon Concentration"       unit="mmol/m3" />
+       <field id="Si"       description="Silicate Concentration"                   unit="mmol/m3" />
+       <field id="PHY"      description="Nanophytoplankton Concentration"          unit="mmol/m3" />
+       <field id="ZOO"      description="Microzooplankton Concentration"           unit="mmol/m3" />
+       <field id="DOC"      description="Dissolved organic Concentration"          unit="mmol/m3" />
+       <field id="PHY2"     description="Diatoms Concentration"                    unit="mmol/m3" />
+       <field id="ZOO2"     description="Mesozooplankton Concentration"            unit="mmol/m3" />
+       <field id="DSi"      description="Diatoms Silicate Concentration"           unit="mmol/m3" />
+       <field id="Fer"      description="Dissolved Iron Concentration"             unit="mmol/m3" />
+       <field id="BFe"      description="Big iron particles Concentration"         unit="mmol/m3" />
+       <field id="GOC"      description="Big organic carbon Concentration"         unit="mmol/m3" />
+       <field id="SFe"      description="Small iron particles Concentration"       unit="mmol/m3" />
+       <field id="DFe"      description="Diatoms iron  Concentration"              unit="mmol/m3" />
+       <field id="GSi"      description="Sinking biogenic Silicate Concentration"  unit="mmol/m3" />
+       <field id="NFe"      description="Nano iron Concentration"                  unit="mmol/m3" />
+       <field id="NCHL"     description="Nano chlorophyl Concentration"            unit="mg/m3" />
+       <field id="DCHL"     description="Diatoms chlorophyl Concentration"         unit="mg/m3" />
+       <field id="NO3"      description="Nitrates Concentration"                   unit="mmol/m3" />
+       <field id="NH4"      description="Ammonium Concentration"                   unit="mmol/m3" />
        <field id="DET"      description="Detritus"                                 unit="mmole-N/m3" />
        <field id="ZOO"      description="Zooplankton Concentration"                unit="mmole-N/m3" />
Index: /trunk/NEMOGCM/SETTE/sette.sh
===================================================================
--- /trunk/NEMOGCM/SETTE/sette.sh	(revision 3531)
+++ /trunk/NEMOGCM/SETTE/sette.sh	(revision 3532)
@@ -11,5 +11,5 @@
 #
 #############################################################
-set -vx
+#set -x
 set -o posix
 #set -u
@@ -84,8 +84,4 @@
 #
 #
-#  prepare_job.sh
-#
-#  to generate the script run_job.sh
-#
 #  fcm_job.sh 
 #
@@ -125,5 +121,5 @@
 # ==========
 #
-# $Id: $
+# $Id: sette.sh 2890 2011-10-06 11:03:48Z flavoni $
 #
 #   * creation
@@ -159,11 +155,11 @@
     export TEST_NAME="LONG"
     cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m ${CMP_NAM} -n GYRELOB_LONG -r GYRE_LOBSTER -j 8  
-    cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=1
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n GYRELOB_LONG -r GYRE_LOBSTER add_key "key_mpp_mpi"
+    cd ${SETTE_DIR}
+    . param.cfg
+    . all_functions.sh
+    . prepare_exe_dir.sh
+    JOB_FILE=${EXE_DIR}/run_job.sh
+    NPROC=4
     \rm ${JOB_FILE}
     cd ${EXE_DIR}
@@ -175,8 +171,11 @@
     set_namelist namelist nn_solv 2
     set_namelist namelist_top ln_diatrc .false.
-    cd ${SETTE_DIR}
-    . ./prepare_job.sh input_GYRE.cfg $NPROC ${TEST_NAME} no ${JOB_FILE}
-    cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} no
+    set_namelist namelist jpni 2
+    set_namelist namelist jpnj 2
+    set_namelist namelist jpnij 4
+    cd ${SETTE_DIR}
+    . ./prepare_job.sh input_GYRE.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
 
     cd ${SETTE_DIR}
@@ -192,6 +191,8 @@
     set_namelist namelist ln_clobber .true.
     set_namelist namelist nn_solv 2
-    ln -s -f ..\/LONG\/GYRELOB_LONG_00000060_restart.nc
-    ln -s -f ..\/LONG\/GYRELOB_LONG_00000060_restart_trc.nc
+    set_namelist namelist jpni 2
+    set_namelist namelist jpnj 2
+    set_namelist namelist jpnij 4
+    cp ..\/LONG\/GYRELOB_LONG_00000060_restart*.nc .
     set_namelist namelist cn_ocerst_in \"GYRELOB_LONG_00000060_restart\"
     set_namelist namelist_top ln_diatrc .false.
@@ -200,14 +201,14 @@
     set_namelist namelist_top cn_trcrst_in \"GYRELOB_LONG_00000060_restart_trc\"
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_GYRE.cfg $NPROC ${TEST_NAME} no ${JOB_FILE}
-    cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} no
+    . ./prepare_job.sh input_GYRE.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
 fi
 
 if [ ${config} -eq 2 ] ;  then
-    ## Reproducibility tests for GYRE_LOBSTER
+    ## Repropducibility tests for GYRE_LOBSTER
     export TEST_NAME="REPRO_1_4"
     cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m ${CMP_NAM} -n GYRELOB_4 -r GYRE_LOBSTER -j 8 add_key "key_mpp_rep key_mpp_mpi"
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n GYRELOB_4 -r GYRE_LOBSTER add_key "key_mpp_mpi key_mpp_rep"
     cd ${SETTE_DIR}
     . param.cfg
@@ -216,5 +217,5 @@
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=4
-    \rm $JOB_FILE
+    \rm ${JOB_FILE}
     cd ${EXE_DIR}
     set_namelist namelist cn_exp \"GYRELOB_14\"
@@ -239,7 +240,4 @@
     export TEST_NAME="REPRO_2_2"
     . prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=4
-    \rm $JOB_FILE
     cd ${EXE_DIR}
     set_namelist namelist cn_exp \"GYRELOB_22\"
@@ -259,4 +257,5 @@
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+
 fi
 
@@ -266,12 +265,12 @@
     export TEST_NAME="LONG"
     cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m ${CMP_NAM} -n ORCA2LIMPIS_LONG -r ORCA2_LIM_PISCES -j 8
-    cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=1
-    \rm $JOB_FILE
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n ORCA2LIMPIS_LONG -r ORCA2_LIM_PISCES -j 8 add_key "key_mpp_mpi" 
+    cd ${SETTE_DIR}
+    . param.cfg
+    . all_functions.sh
+    . prepare_exe_dir.sh
+    JOB_FILE=${EXE_DIR}/run_job.sh
+    NPROC=4
+    \rm ${JOB_FILE}
     cd ${EXE_DIR}
     set_namelist namelist cn_exp \"O2LP_LONG\"
@@ -280,4 +279,7 @@
     set_namelist namelist nn_stock 75
     set_namelist namelist ln_clobber .true.
+    set_namelist namelist jpni 2
+    set_namelist namelist jpnj 2
+    set_namelist namelist jpnij 4
     set_namelist namelist nn_solv 2
     set_namelist namelist_top ln_trcdta .false.
@@ -291,10 +293,10 @@
     set_namelist namelist_pisces ln_presatm .false.
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ORCA2_LIM_PISCES.cfg $NPROC ${TEST_NAME} no ${JOB_FILE}
-    cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC  ${JOB_FILE} ${INTERACT_FLAG} no
-#
+    . ./prepare_job.sh input_ORCA2_LIM_PISCES.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+    
+    cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
-    cd ${SETTE_DIR}
     . prepare_exe_dir.sh
     cd ${EXE_DIR}
@@ -306,8 +308,9 @@
     set_namelist namelist nn_rstctl 2
     set_namelist namelist ln_clobber .true.
-    set_namelist namelist nn_solv 2
-    ln -s -f ../LONG/O2LP_LONG_00000075_restart.nc
-    ln -s -f ../LONG/O2LP_LONG_00000075_restart_ice.nc
-    ln -s -f ../LONG/O2LP_LONG_00000075_restart_trc.nc
+    set_namelist namelist jpni 2
+    set_namelist namelist jpnj 2
+    set_namelist namelist jpnij 4
+    set_namelist namelist nn_solv 2
+    cp ../LONG/O2LP_LONG_00000075_restart*nc .
     set_namelist namelist cn_ocerst_in \"O2LP_LONG_00000075_restart\"
     set_namelist namelist_ice cn_icerst_in \"O2LP_LONG_00000075_restart_ice\"
@@ -324,11 +327,11 @@
     set_namelist namelist_pisces ln_presatm .false.
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ORCA2_LIM_PISCES.cfg $NPROC ${TEST_NAME} no ${JOB_FILE}
-    cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} no
+    . ./prepare_job.sh input_ORCA2_LIM_PISCES.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
 fi
 
 if [ ${config} -eq 4 ] ;  then
-    ## Reproducibility tests for ORCA2_LIM_PISCES
+    ## Repropducibility tests for ORCA2_LIM_PISCES
     export TEST_NAME="REPRO_4_4"
     cd ${SETTE_DIR}
@@ -345,4 +348,5 @@
     set_namelist namelist nn_itend 75
     set_namelist namelist nn_fwb 0
+    set_namelist namelist ln_ctl .false.
     set_namelist namelist ln_clobber .true.
     set_namelist namelist jpni 4
@@ -362,16 +366,14 @@
     . ./prepare_job.sh input_ORCA2_LIM_PISCES.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
     cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG} 
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
 
     cd ${SETTE_DIR}
     export TEST_NAME="REPRO_2_8"
     . prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=16
-    \rm $JOB_FILE
     cd ${EXE_DIR}
     set_namelist namelist nn_it000 1
     set_namelist namelist nn_itend 75
     set_namelist namelist nn_fwb 0
+    set_namelist namelist ln_ctl .false.
     set_namelist namelist ln_clobber .true.
     set_namelist namelist jpni 2
@@ -399,11 +401,11 @@
     export TEST_NAME="LONG"
     cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m ${CMP_NAM} -n ORCA2OFFPIS_LONG -r ORCA2_OFF_PISCES -j 8 
-    cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=1
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n ORCA2OFFPIS_LONG -r ORCA2_OFF_PISCES -j 8 add_key "key_mpp_rep"
+    cd ${SETTE_DIR}
+    . param.cfg
+    . all_functions.sh
+    . prepare_exe_dir.sh
+    JOB_FILE=${EXE_DIR}/run_job.sh
+    NPROC=4
     \rm $JOB_FILE
     cd ${EXE_DIR}
@@ -413,4 +415,7 @@
     set_namelist namelist nn_stock 20
     set_namelist namelist ln_clobber .true.
+    set_namelist namelist jpni 2
+    set_namelist namelist jpnj 2
+    set_namelist namelist jpnij 4
     set_namelist namelist_top ln_trcdta .false.
     set_namelist namelist_top ln_diatrc .false.
@@ -424,8 +429,13 @@
     cd ${SETTE_DIR}
     . ./prepare_job.sh input_ORCA2_OFF_PISCES.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
     
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
     . prepare_exe_dir.sh
+    JOB_FILE=${EXE_DIR}/run_job.sh
+    NPROC=4
+    \rm $JOB_FILE
     cd ${EXE_DIR}
     set_namelist namelist cn_exp \"OFFP_SHORT\"
@@ -434,5 +444,8 @@
     set_namelist namelist nn_stock 20
     set_namelist namelist ln_clobber .true.
-    ln -s ../LONG/OFFP_LONG_00000020_restart_trc.nc .
+    set_namelist namelist jpni 2
+    set_namelist namelist jpnj 2
+    set_namelist namelist jpnij 4
+    cp ../LONG/OFFP_LONG_00000020_restart*nc .
     set_namelist namelist_top ln_diatrc .false.
     set_namelist namelist_top ln_rsttr .true.
@@ -453,5 +466,5 @@
 
 if [ ${config} -eq 6 ] ;  then
-    ## Reproducibility tests for ORCA2_OFF_PISCES
+    ## Repropducibility tests for ORCA2_OFF_PISCES
     export TEST_NAME="REPRO_4_4"
     cd ${SETTE_DIR}
@@ -467,4 +480,5 @@
     set_namelist namelist nn_it000 1
     set_namelist namelist nn_itend 40
+    set_namelist namelist ln_ctl .false.
     set_namelist namelist ln_clobber .true.
     set_namelist namelist jpni 4
@@ -483,15 +497,13 @@
     . ./prepare_job.sh input_ORCA2_OFF_PISCES.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
     cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC  ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
 
     cd ${SETTE_DIR}
     export TEST_NAME="REPRO_2_8"
     . prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=16
-    \rm $JOB_FILE
     cd ${EXE_DIR}
     set_namelist namelist nn_it000 1
     set_namelist namelist nn_itend 40
+    set_namelist namelist ln_ctl .false.
     set_namelist namelist ln_clobber .true.
     set_namelist namelist jpni 2
@@ -513,61 +525,9 @@
 fi
 
-# TESTS FOR AMM12 CONFIGURATION
 if [ ${config} -eq 7 ] ;  then
-    ## Reproducibility tests for AMM12
-    export TEST_NAME="REPRO_8_4"
-    cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m ${CMP_NAM} -n AMM12_32 -r AMM12 -j 8 add_key "key_mpp_rep"
-    cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=32
-    \rm $JOB_FILE
-    cd ${EXE_DIR}
-    set_namelist namelist nn_it000 1
-    set_namelist namelist nn_itend 576
-    set_namelist namelist nn_fwb 0
-    set_namelist namelist ln_ctl .false.
-    set_namelist namelist ln_clobber .true.
-    set_namelist namelist nn_dyn2d 2
-    set_namelist namelist nn_tra_dta 0
-    set_namelist namelist jpni 8
-    set_namelist namelist jpnj 4
-    set_namelist namelist jpnij 32
-    cd ${SETTE_DIR}
-    . ./prepare_job.sh input_AMM12.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
-    cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC  ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
-
-    cd ${SETTE_DIR}
-    export TEST_NAME="REPRO_4_8"
-    . prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=32
-    \rm $JOB_FILE
-    cd ${EXE_DIR}
-    set_namelist namelist nn_it000 1
-    set_namelist namelist nn_itend 576
-    set_namelist namelist nn_fwb 0
-    set_namelist namelist ln_ctl .false.
-    set_namelist namelist nn_dyn2d 2
-    set_namelist namelist nn_tra_dta 0
-    set_namelist namelist ln_clobber .true.
-    set_namelist namelist jpni 4
-    set_namelist namelist jpnj 8
-    set_namelist namelist jpnij 32
-    cd ${SETTE_DIR}
-    . ./prepare_job.sh input_AMM12.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
-    cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC  ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
-fi
-
-if [ ${config} -eq 8 ] ;  then
     ## Restartability tests for AMM12
     export TEST_NAME="LONG"
     cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m ${CMP_NAM} -n AMM12_LONG -r AMM12 -j 8 add_key "key_mpp_rep"
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n AMM12_LONG -r AMM12 
     cd ${SETTE_DIR}
     . param.cfg
@@ -610,9 +570,58 @@
     set_namelist namelist ln_rstart .true.
     set_namelist namelist nn_rstctl 2
-    set_namelist namelist cn_ocerst_in \"../LONG/AMM12_00000006_restart\"
+    set_namelist namelist cn_ocerst_in \"AMM12_00000006_restart\"
+    cp ../LONG/AMM12_00000006_restart*.nc .
     cd ${SETTE_DIR}
     . ./prepare_job.sh input_AMM12.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
     cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC  ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+fi
+
+if [ ${config} -eq 8 ] ;  then
+    ## Reproducibility tests for AMM12
+    export TEST_NAME="REPO_8_4"
+    cd ${SETTE_DIR}
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n AMM12_32 -r AMM12 add_key "key_mpp_rep"
+    cd ${SETTE_DIR}
+    . param.cfg
+    . all_functions.sh
+    . prepare_exe_dir.sh
+    JOB_FILE=${EXE_DIR}/run_job.sh
+    NPROC=32
+    \rm ${JOB_FILE}
+    cd ${EXE_DIR}
+    set_namelist namelist nn_it000 1
+    set_namelist namelist nn_itend 576
+    set_namelist namelist nn_fwb 0
+    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist nn_dyn2d 2
+    set_namelist namelist nn_tra_dta 0
+    set_namelist namelist jpni 8
+    set_namelist namelist jpnj 4
+    set_namelist namelist jpnij 32
+    cd ${SETTE_DIR}
+    . ./prepare_job.sh input_AMM12.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+
+    cd ${SETTE_DIR}
+    export TEST_NAME="REPO_4_8"
+    . prepare_exe_dir.sh
+    cd ${EXE_DIR}
+    set_namelist namelist nn_it000 1
+    set_namelist namelist nn_itend 576
+    set_namelist namelist nn_fwb 0
+    set_namelist namelist ln_ctl .false.
+    set_namelist namelist nn_dyn2d 2
+    set_namelist namelist nn_tra_dta 0
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist jpni 4
+    set_namelist namelist jpnj 8
+    set_namelist namelist jpnij 32
+    cd ${SETTE_DIR}
+    . ./prepare_job.sh input_AMM12.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
 fi
 
@@ -629,5 +638,5 @@
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=2
-    \rm $JOB_FILE
+    \rm ${JOB_FILE}
     cd ${EXE_DIR}
     set_namelist namelist nn_it000 1
@@ -645,5 +654,5 @@
     . ./prepare_job.sh input_ORCA2_LIM_AGRIF.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}
     cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC  ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
 fi
 